#pragma once

#include <kernel/proc.h>
#include<kernel/cpu.h>
#include<common/spinlock.h>
void early_init();
void init_sched();
void init_schinfo(struct schinfo *);

bool _activate_proc(Proc *, bool onalert);
#define activate_proc(proc) _activate_proc(proc, false)
#define alert_proc(proc) _activate_proc(proc, true)
#define NUM_PRIORITY 25

WARN_RESULT bool is_zombie(Proc *);
WARN_RESULT bool is_unused(Proc *);
void acquire_sched_lock();
void release_sched_lock();
void sched(enum procstate new_state);
void sched_timer_handler(struct timer*);

// MUST call lock_for_sched() before sched() !!!
#define yield() (acquire_sched_lock(), sched(RUNNABLE))
WARN_RESULT Proc *thisproc();
void sleep(int dalay);
int fork_for_RT(int cid);
bool _activate_proc_with_id(Proc *p, bool onalert,int cid);
void init_cr_resources();
void Insched_timer_handler(struct timer* tim);