#include <kernel/sched.h>
#include <common/sem.h>
#include <test/test.h>
#include <kernel/mem.h>
#include <kernel/printk.h>
#include <kernel/proc.h>


#define PROC_CR_COUNT 5 // 每个进程最多持有的 CR 锁数量
#define NUM_PROCS 10
static int thread_count=0;


// static void RT_test_print(u64 a){
//     u64 i =0;
//     while(1){
//         volatile int  b = 2;
//         volatile int  c=a+b;
//         a= b-c;
//         i++;
//         if(thread_count<5)
//             i=0;
//         if(i>=a*100+123&&thread_count>=NUM_PROCS){
//            sleep(10);
//            i=0;
//             acquire_sched_lock();
//             sched(RUNNABLE);
//         }
//     }
    
// }

static void RT_test_priority(u64 a){
    thisproc()->currfuncid=1;
    u64 i =0;
    //static CR *cr_list[PROC_CR_COUNT];
    //random_cr_select(cr_list);
    while(1){
        volatile int  b = 2;
        volatile int  c=a+b;
        a= b-c;
        i++;
        if(i>=a*100+123&&thread_count>=10){
            i=0;
            if (acquire_CR((a*i+a)%20)) {
                printk("cpu %lld,pid %d Successfully acquired CR %lld lock! %lld \n",cpuid(),thisproc()->pid,(a*i+a)%20,(i+a)%10);
            } else {
                printk("cpu %lld,pid %d Failed to acquire CR %lld lock. %lld\n",cpuid(),thisproc()->pid,(a*i+a)%20,(i+a)%10);
            }
            sleep(10);
            acquire_sched_lock();
            sched(RUNNABLE);
        }
    }
}
void rbtree_test()
{
    printk("RTOS_test\n");
   
    //抢占的测试
    // for (int i = 0; i < NUM_PROCS; i++) {
    //     auto p = RT_create((i+1)*100,10*(i+1));
    //     set_parent_to_this(p);
    //     start_proc(p, RT_test_print, i);
    //     thread_count++;
    // }

    //优先级测试(MQ with Lazy的版本中，还未支持)
    for (int cid =0 ;cid<2;cid++){
        for(int i =0;i<10;i++){
        auto p = RT_create((i+1)*100,10*(i+1));
        set_parent_to_this(p);
        start_proc_with_id(p, RT_test_priority, i,cid);
        thread_count++;
        }
    }
    while(1){
        acquire_sched_lock();
        sched(RUNNABLE);
    }
}